package gus05.manager.gus.kassia.layer2;

import gus05.manager.gus.kassia.layer1.KassiaApp;
import gus05.manager.gus.kassia.layer1.organs.*;
import gus05.manager.gus.kassia.layer2.organs_impl.*;


public class KassiaMain extends KassiaApp {
    
    public static void main(String[] args)
    {new KassiaMain(args);}
    
    public KassiaMain(String[] args) {super(args);}
    
    protected KeyFinder buildKeyFinder()                {return new Impl_KeyFinder();}
    protected ServiceWrapper buildServiceWrapper()      {return new Impl_ServiceWrapper();}
    protected ResourceProvider buildResourceProvider()  {return new Impl_ResourceProvider();}
    protected ErrorHandler buildErrorHandler()          {return new Impl_ErrorHandler();}
    protected AppLauncher buildAppLauncher()            {return new Impl_AppLauncher();}
}
