
package gus05.manager.gus.kassia.layer2.organs_impl;


import gus05.framework.core.Service;
import gus05.framework.features.Transform;
import gus05.manager.gus.kassia.layer1.Source;
import gus05.manager.gus.kassia.layer1.organs.ServiceWrapper;
import gus05.manager.gus.kassia.layer2.KassiaSystem;
import gus05.manager.gus.kassia.layer2.services.*;


public class Impl_ServiceWrapper implements ServiceWrapper {
	
    
    public Service wrapService(Source src, Object obj) throws Exception
    {
    	Transform t = KassiaSystem.findServiceWrapper();
        if(t!=null) return (Service) t.transform(toDataTab(src,obj));
        
    	if(obj==null) return new EmptyService();
        return new DefaultService(src,obj);
    }
    
    
    
    private Object[] toDataTab(Source src, Object obj)
    {return new Object[]{src.getEntity(),src.getId(),obj};}
}
