package gus05.manager.gus.kassia.layer3;


import java.applet.AudioClip;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintStream;
import java.net.URL;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Properties;
import java.util.Set;

import javax.swing.Icon;
import javax.swing.JFrame;
import javax.swing.JMenuBar;
import javax.swing.tree.TreeModel;

import gus05.framework.core.Entity;
import gus05.framework.features.Execute;
import gus05.framework.features.Give;
import gus05.framework.features.Provide;
import gus05.framework.features.Register;
import gus05.framework.features.Retrieve;
import gus05.framework.features.Transform;
import gus05.framework.resources.FileProvider;
import gus05.framework.resources.StringProvider;
import gus05.framework.tools.DefaultSupport;
import gus05.manager.gus.kassia.layer3.tools.crypting.Crypter;
import gus05.manager.gus.kassia.layer3.tools.printstream.PrintStream0;



public class KS3_data extends KS2_tool {

	
	
	public static PrintStream p_log()			{return (PrintStream) getPool(POOL_PRINTSTREAM_APP_LOG);}
	public static PrintStream p_out()			{return (PrintStream) getPool(POOL_PRINTSTREAM_APP_OUT);}
	public static PrintStream p_err()			{return (PrintStream) getPool(POOL_PRINTSTREAM_APP_ERR);}
	
	public static Map map_props()				{return poolmap(POOL_MAP_PROPS);}
	public static Map map_files()				{return poolmap(POOL_MAP_FILES);}
	public static FileProvider fp() 			{return (FileProvider) getPool(POOL_FILEPROVIDER);}
	public static FileProvider fp_pool() 		{return (FileProvider) getPool(POOL_FILEPROVIDER_POOL);}
	
	public static Map map_entityOrigines()		{return poolmap(POOL_MAP_ENTITYORIGINES);}
	public static Map map_entityClasses()		{return poolmap(POOL_MAP_ENTITYCLASSES);}
	public static Map map_entityInstances()		{return poolmap(POOL_MAP_ENTITYINSTANCES);}
	public static Map map_instanceNumber()		{return poolmap(POOL_MAP_ENTITYINSTANCENUMBERS);}
	public static Map map_creationDates()		{return poolmap(POOL_MAP_ENTITYCREATIONDATES);}
	public static Map map_lastUsedDates()		{return poolmap(POOL_MAP_ENTITYLASTUSEDDATES);}
	public static Map map_lastBuildTime()		{return poolmap(POOL_MAP_ENTITYLASTBUILDTIMES);}
	public static Map map_maxBuildTime()		{return poolmap(POOL_MAP_ENTITYMAXBUILDTIMES);}
	public static Map map_sumBuildTime()		{return poolmap(POOL_MAP_ENTITYSUMBUILDTIMES);}
	public static Map map_creationTrack()		{return poolmap(POOL_MAP_ENTITYCREATIONTRACK);}
    
	public static Map map_icons()				{return poolmap(POOL_MAP_ICONS);}
	public static Map map_actions()				{return poolmap(POOL_MAP_ACTIONS);}
	public static Map map_sounds()				{return poolmap(POOL_MAP_SOUNDS);}
	public static Map map_lings()				{return poolmap(POOL_MAP_LINGS);}
	public static Set set_languages()			{return poolset(POOL_SET_LANGUAGES);}
	public static Map map_providers()			{return poolmap(POOL_MAP_PROVIDERS);}
	public static Map map_multiplicity()		{return poolmap(POOL_MAP_ENTITYMULTIPLICITY);}
	
	public static Map map_dataObject()			{return poolmap(POOL_MAP_DATAOBJECT);}
	public static Map map_dataSource()			{return poolmap(POOL_MAP_DATASOURCE);}
	
	private static Retrieve entityProvider1()	{return poolret(POOL_RETRIEVE_ENTITYPROVIDER1);}
	private static Retrieve entityProvider2()	{return poolret(POOL_RETRIEVE_ENTITYPROVIDER2);}
	private static Retrieve entityProvider3()	{return poolret(POOL_RETRIEVE_ENTITYPROVIDER3);}
	
	public static Retrieve entityGenerator()	{return poolret(POOL_RETRIEVE_ENTITYGENERATOR);}
	public static Retrieve entityClassHolder()	{return poolret(POOL_RETRIEVE_ENTITYCLASSHOLDER);}
	public static Give entityLoader()			{return poolgive(POOL_GIVE_ENTITYLOADER);}
	public static Retrieve entityClassLoader()	{return poolret(POOL_RETRIEVE_ENTITYCLASSLOADER);}
	public static Transform entityLoader_jar()	{return pooltran(POOL_TRANSFORM_ENTITYCLASSLOADER_JAR);}
	public static Transform entityLoader_bin()	{return pooltran(POOL_TRANSFORM_ENTITYCLASSLOADER_BIN);}
	
	public static Retrieve dataProvider()		{return poolret(POOL_RETRIEVE_DATAPROVIDER);}
	public static Retrieve dataSourceFinder()	{return poolret(POOL_RETRIEVE_DATASOURCEFINDER);}
	
	public static Provide mainGuiProvider()		{return poolpro(POOL_PROVIDE_MAINGUIBUILDER);}
	
	public static Give dataBuilder()			{return poolgive(POOL_GIVE_DATABUILDER);}
	public static Give dataPersistence()		{return poolgive(POOL_GIVE_DATAPERSISTENCE);}
	public static Give dataBackup()				{return poolgive(POOL_GIVE_DATABACKUP);}
	
	public static Execute executeExit()			{return poolexe(POOL_EXECUTE_EXIT);}
	
	public static DefaultSupport supportExit()	{return poolsup(POOL_SUPPORT_EXIT);}
	public static DefaultSupport supportExit2()	{return poolsup(POOL_SUPPORT_EXIT2);}
	public static DefaultSupport supportStart()	{return poolsup(POOL_SUPPORT_START);}
	public static DefaultSupport supportLing()	{return poolsup(POOL_SUPPORT_LING);}
	
	public static Transform uencoder()			{return pooltran(POOL_TRANSFORM_UENCODER);}
	public static Transform udecoder()			{return pooltran(POOL_TRANSFORM_UDECODER);}
	
	public static JFrame mainFrame()			{return (JFrame) getPool(POOL_JFRAME_APPFRAME);}
	public static JMenuBar menuBar()			{return (JMenuBar) getPool(POOL_JMENUBAR_APPMENUBAR);}
	
	public static List startedList()			{return poollist(POOL_LIST_STARTEDENTITIES);}
	
	
	
	
	
	/*
	 * APPLICATION PHASES
	 */
	private static int phase = 0;
	
	private static void nextPhase(int nextPhase, String title)
    {
		phase = nextPhase;
    	println("");
    	println("PHASE "+phase+": "+title);
    }
	
	public static void nextPhase_poolInitialization()
	{nextPhase(PHASE_POOLINITIALISATION,"POOL INITIALIZATION");}
	
	public static void nextPhase_applicationBuild()
	{nextPhase(PHASE_APPLICATIONBUILD,"APPLICATION BUILD");}
	
	public static void nextPhase_applicationStart()
	{nextPhase(PHASE_APPLICATIONSTART,"APPLICATION START");}
	
	public static void nextPhase_applicationSummary()
	{nextPhase(PHASE_APPLICATIONSUMMARY,"APPLICATION SUMMARY");}
	
	public static void nextPhase_applicationRuntime()
	{nextPhase(PHASE_APPLICATIONRUNTIME,"APPLICATION RUNTIME");}
	
	public static void nextPhase_applicationExit()
	{nextPhase(PHASE_APPLICATIONEXIT,"APPLICATION EXIT");}
	
	public static boolean isPhase_poolInitialization()		{return phase==PHASE_POOLINITIALISATION;}
	public static boolean isPhase_applicationBuild()		{return phase==PHASE_APPLICATIONBUILD;}
	public static boolean isPhase_applicationStart()		{return phase==PHASE_APPLICATIONSTART;}
	public static boolean isPhase_applicationSummary()		{return phase==PHASE_APPLICATIONSUMMARY;}
	public static boolean isPhase_applicationRuntime()		{return phase==PHASE_APPLICATIONRUNTIME;}
	public static boolean isPhase_applicationExit()			{return phase==PHASE_APPLICATIONEXIT;}
	
	
	
	
	
	
	
    
    
    /*
     * PRINT INSIDE LOG
     */
	private static void println(String m)
	{p_log().println(m);}
	
	public static void print(String type, Object source, String id, String message)
	{println(now()+" "+phase+" "+errors.size()+" ["+type+"] "+sourceName(source)+"@"+id+"\t"+message);}
	
	public static void printM(Object source, String id, String message)
	{print("M",source,id,message);}
	
	public static void printW(Object source, String id, String message)
	{print("W",source,id,message);}
	
	public static void printE(Object source, String id, String message)
	{print("E",source,id,message);}
	
	public static void printD(Object source, String id, String message)
	{if(debug())print("D",source,id,message);}
	
	
	
	
	public static String src(Entity entity, String id)
	{return entity.getName()+"@"+id;}
	
	public static String src(String entityName, String id)
	{return entityName+"@"+id;}
	
	
	
	
	public static Object findElement(String key) throws Exception
    {
    	if(hasPool(key)) return getPool(key);
    	String name = getProp(key,null);
        return name!=null?provideUniqueEntity(name):null;
    }
	
	
	
	
	
	
	
	
	/*
     * PROPERTIES
     */
    public static boolean hasProp(String key)
    {return map_props().containsKey(key);}
    
    public static String getProp(String key)
    {return (String) map_props().get(key);}
    
    public static void setProp(String key, String value)
    {map_props().put(key,value);}
    
    public static void addProp(Properties p)
    {map_props().putAll(p);}
    
    public static String getProp(String key, String defaultValue)
    {return hasProp(key)? getProp(key):defaultValue;}
    
    public static String getProp_u(String key)
    {return getProp(key,"UNDEFINED");}
    
    public static boolean booleanProp(String key, boolean defaultValue)
    {return hasProp(key)? getProp(key).equalsIgnoreCase("true"):defaultValue;}
    
    public static int intProp(String key, int defaultValue)
    {return hasProp(key)? Integer.parseInt(getProp(key)):defaultValue;}
    
    public static long longProp(String key, long defaultValue)
    {return hasProp(key)? Long.parseLong(getProp(key)):defaultValue;}
    
    
    
    
    
	
	
	/*
	 * FILE IDS
	 */
	public static File file(String key)
    {return fp().getFile(key);}
	
	public static boolean hasFile(String key)
    {return fp().getFile(key)!=null;}
	
	public static File poolFile(Entity entity, String id)
    {return fp_pool().getFile(src(entity,id)+".txt");}
	
	public static File poolDir(Entity entity, String id)
    {return fp_pool().getFile(src(entity,id));}
	
	
	
	
	
	
	
	
	
	
	public static Icon icon(String key)
    {
		if(!hasIcon(key)) return null;
		return (Icon) map_icons().get(key);
	}
	
	public static Icon icon(String entityName, String key)
    {
		Icon i = icon(src(entityName,key));
		if(i!=null) return i;
		return icon(key);
	}
	
	public static Icon icon(Entity entity, String key)
    {
		Icon i = icon(src(entity,key));
		if(i!=null) return i;
		return icon(key);
	}
	
	
	
	
	public static Icon icon1(String key)
    {
		Icon i = icon(key);
		return i!=null?i:icon(ICONID_DEFAULT);
	}
	
	public static Icon icon1(String entityName, String key)
    {
		Icon i = icon(entityName,key);
		return i!=null?i:icon(ICONID_DEFAULT);
	}
	
	public static Icon icon1(Entity entity, String key)
    {
		Icon i = icon(entity,key);
		return i!=null?i:icon(ICONID_DEFAULT);
	}
	
	
	
	
	
	public static boolean hasIcon(String key)
	{
		if(key==null || key.equals("")) return false;
		Map m = map_icons(); if(m==null) return false;
		return m.containsKey(key);
	}
	
	public static boolean hasIcon(String entityName, String key)
	{
		if(key==null || key.equals("")) return false;
		Map m = map_icons(); if(m==null) return false;
		if(m.containsKey(src(entityName,key))) return true;
		return m.containsKey(key);
	}
	
	public static boolean hasIcon(Entity entity, String key)
	{
		if(key==null || key.equals("")) return false;
		Map m = map_icons(); if(m==null) return false;
		if(m.containsKey(src(entity,key))) return true;
		return m.containsKey(key);
	}
	
	
	
	
	
	
	
	
	
	
	public static AudioClip sound(String key)
    {
		Map m = map_sounds();
		return hasSound(key)?(AudioClip) m.get(key):null;
	}
    
	public static AudioClip sound(String entityName, String key)
    {
		AudioClip s = sound(src(entityName,key));
		if(s!=null) return s;
		return sound(key);
	}
	
	public static AudioClip sound(Entity entity, String key)
    {
		AudioClip s = sound(src(entity,key));
		if(s!=null) return s;
		return sound(key);
	}
	
	
	
	
	public static boolean hasSound(String key)
	{
		if(key==null || key.equals("")) return false;
		Map m = map_sounds(); if(m==null) return false;
		return m.containsKey(key);
	}
	
	public static boolean hasSound(String entityName, String key)
	{
		if(key==null || key.equals("")) return false;
		Map m = map_sounds(); if(m==null) return false;
		if(m.containsKey(src(entityName,key))) return true;
		return m.containsKey(key);
	}
	
	public static boolean hasSound(Entity entity, String key)
	{
		if(key==null || key.equals("")) return false;
		Map m = map_sounds(); if(m==null) return false;
		if(m.containsKey(src(entity,key))) return true;
		return m.containsKey(key);
	}
	
	
	
	
	
	
	
	
	
	public static String ling(String key)
	{
		StringProvider sp = (StringProvider) getPool(POOL_STRINGPROVIDER_LING);
		if(sp==null) return key;
		return sp.getString(key);
	}
	
	public static String ling(String entityName, String key)
	{
		String src = src(entityName,key);
		String s = ling(src);
		if(!s.equals(src)) return s;
		return ling(key);
	}
	
	public static String ling(Entity entity, String key)
	{
		String src = src(entity,key);
		String s = ling(src);
		if(!s.equals(src)) return s;
		return ling(key);
	}
	
	
	
	
	public static boolean hasLing(String key)
	{
		String s = ling(key);
		return !s.equals(key);
	}
	
	public static boolean hasLing(String entityName, String key)
	{
		String src = src(entityName,key);
		if(hasLing(src)) return true;
		return hasLing(key);
	}
	
	public static boolean hasLing(Entity entity, String key)
	{
		String src = src(entity,key);
		if(hasLing(src)) return true;
		return hasLing(key);
	}
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
    
	
	public static void askExit()
	{	
		try
		{
			Execute exe = executeExit();
			if(exe==null) throw new Exception("ExecuteExit not available inside pool");
			exe.execute();
		}
		catch(Exception e)
		{
			err(KS3_data.class,"askExit()",e);
			System.err.println("Exit failed... System.exit(1)");
			System.exit(1);
		}
	}
	


	
	public static void forceExit()
	{	
		try
		{
			Execute exe = executeExit();
			if(exe==null) throw new Exception("ExecuteExit not available inside pool");
			putPool(POOL_FILTER_CONFIRMEXIT,trueFilter);
			removePool(POOL_OBJ_EXITTRIGGER);
			exe.execute();
			throw new Exception("ExecuteExit dit not exit the application");
		}
		catch(Exception e)
		{
			err(KS3_data.class,"forceExit()",e);
			System.err.println("Exit failed... System.exit(1)");
			System.exit(1);
		}
	}


	
	
	
	
	public static String getDefaultMultiplicity()
	{return getProp(PROPKEY_DEFAULTMULTIPLICITY,MULTIPLICITYVALUE_DEFAULT);}
	
	
	public static String getMultiplicity(String entityName)
	{
		Map m = map_multiplicity();
		if(m==null) return getDefaultMultiplicity();
		if(!m.containsKey(entityName)) return getDefaultMultiplicity();
		return (String) m.get(entityName);
	}
	
	
	public static boolean isMultiple(String entityName)
	{return getMultiplicity(entityName).equals(MULTIPLICITYVALUE_MULTIPLE);}
	
	public static boolean isUnique(String entityName)
	{return getMultiplicity(entityName).equals(MULTIPLICITYVALUE_UNIQUE);}
	
	
	
	
	public static Entity provideUniqueEntity(String entityName) throws Exception
	{
		Retrieve ret = entityProvider1();
		if(ret==null) throw new Exception("Entity provider 1 not available inside pool");
		return (Entity) ret.retrieve(entityName);
	}
	
	
	public static Entity provideUniqueEntity(String entityName, String storeKey) throws Exception
	{
		Retrieve ret = entityProvider2();
		if(ret==null) throw new Exception("Entity provider 2 not available inside pool");
		((Register)ret).register("entityName",entityName);
		return (Entity) ret.retrieve(storeKey);
	}
	
	
	public static Entity provideEntity(String entityName) throws Exception
	{
		Retrieve ret = entityProvider3();
		if(ret==null) throw new Exception("Entity provider 3 not available inside pool");
		return (Entity) ret.retrieve(entityName);
	}
	
	
	public static Entity generateEntity(String entityName) throws Exception
	{
		Retrieve ret = entityGenerator();
		if(ret==null) return createInternalEntity(entityName);
		return (Entity) ret.retrieve(entityName);
	}

	
	public static Entity createInternalEntity(String name) throws Exception
    {
        if(!entities.containsKey(name))
            throw new Exception("Unknown internal entity: ["+name+"]");
        Class c = (Class) entities.get(name);
        return instanciateEntity(c,name);
    }
	
	
	public static final Entity ANONYMOUS_ENTITY = new Entity() {
		public String getCreationDate() {return "2010.07.22";}
		public String getName() {return "anonymousentity";}
	};
	
	
	
	
	
	
	
	
	
	
	
	public static void initFile(File file) throws Exception
	{
		if(file==null || file.exists()) return;
		Register fi = poolreg(POOL_REGISTER_FILEINITIALIZER);
    	if(fi!=null) fi.register("file",file);
    	else file.createNewFile();
	}
	
	public static void initFile1(File file) throws Exception
	{
		if(file==null || file.exists()) return;
		file.createNewFile();
	}
	
	public static void initDir(File dir) throws Exception
	{
		if(dir==null || dir.exists()) return;
		Register fi = poolreg(POOL_REGISTER_FILEINITIALIZER);
    	if(fi!=null) fi.register("dir",dir);
    	else dir.mkdirs();
	}
	
	public static void initDir1(File dir) throws Exception
	{
		if(dir==null || dir.exists()) return;
		dir.mkdirs();
	}
	
	
	public static Object getData(String id) throws Exception
	{
		Retrieve r = dataProvider();
		if(r==null) throw new Exception("Data provider not available inside pool");
		return r.retrieve(id);
	}
	
	public static List getDataList(String id) throws Exception
	{return (List) getData(id);}
	
	public static Set getDataSet(String id) throws Exception
	{return (Set) getData(id);}
	
	public static Map getDataMap(String id) throws Exception
	{return (Map) getData(id);}
	
	public static TreeModel getDataTree(String id) throws Exception
	{return (TreeModel) getData(id);}
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	public static String javaVersionGap()
    {
    	if(!hasPool(POOL_STRINGARRAY_JAVAVERSIONGAP)) return "";
    	String[] gap = (String[]) getPool(POOL_STRINGARRAY_JAVAVERSIONGAP);
    	return " ("+gap[1]+" required)";
    }
	
	
	
	
	
	public static String appTitle()
	{return getProp_u(PROPKEY_APPTITLE);}
	
	public static String appName()
	{return getProp_u(PROPKEY_APPNAME);}
	
	public static String appVersion()
	{return getProp_u(PROPKEY_APPVERSION);}
	
	public static String appBuild()
	{return getProp_u(PROPKEY_APPBUILD);}
	
	public static String appGus05ID()
	{return appName()+"|"+appVersion()+"|"+appBuild();}
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	/*
	 * CRYPTER
	 */
	
	private static Crypter crypter;
	
	private static Crypter crp() throws Exception
	{
		if(crypter==null) crypter = new Crypter(getProp(PROPKEY_CRYPTINGINFO,""));
		return crypter;
	}
	
	public static String encrypt(String text, File file)  throws Exception {return crp().ENCRYPT(text,file);}
	public static String decrypt(String text, File file)  throws Exception {return crp().DECRYPT(text,file);}
    
	public static Properties encrypt(Map map, File file)  throws Exception {return crp().encrypt(map,file);}
	public static Properties decrypt(Map map, File file)  throws Exception {return crp().decrypt(map,file);}
	
	
	
	
	
	
	public static Properties prop_S(File file) throws Exception
    {
    	Properties prop = prop(file);
        return encrypt(prop,file);
    }
	
	public static String encodeU(String text) throws Exception
	{return (String) uencoder().transform(text);}
	
	public static String decodeU(String text) throws Exception
	{return (String) udecoder().transform(text);}
	
	public static PrintStream printStreamU(File file) throws FileNotFoundException
    {return new PrintStreamU(file);}
    
    public static PrintStream printStreamUS(File file) throws FileNotFoundException
    {return new PrintStreamUS(file);}
	
    
	
    
	
	private static class PrintStreamU extends PrintStream0
	{
	    public PrintStreamU(File f) throws FileNotFoundException
	    {super(f);}
	    
	    public void print(String m)
	    {
	    	try{super.print(encodeU(m));}
	    	catch(Exception e){err(this,"print(String)",e);}
	    }
	}
	
	
	
	private static class PrintStreamUS extends PrintStream0
	{
	    private File f;
	    public PrintStreamUS(File f) throws FileNotFoundException
	    {super(f);this.f=f;}
	    
	    public void print(String m)
	    {
	    	try{super.print(encodeU(encrypt(m,f)));}
	    	catch(Exception e){err(this,"print(String)",e);}
	    }
	}

	
	
	
	
	public static String text_U(File file) throws Exception
    {return decodeU(text(file));}
    
    public static String text_U(URL url) throws Exception
    {return decodeU(text(url));}
    
    public static String text_US(String text, File file) throws Exception
    {return decodeU(decrypt(text,file));}
    
    public static String text_US(File file) throws Exception
    {return text_US(text(file),file);}
    
    
    
	
    
    public static Set set_U(String text) throws Exception
    {return new HashSet(list_U(text));}
    
    public static Set set_U(File file) throws Exception
    {return new HashSet(list_U(file));}
    
    public static Set set_U(URL url) throws Exception
    {return new HashSet(list_U(url));}
    
    public static Set set_US(File file) throws Exception
    {return new HashSet(list_US(file));}
    
    
    
	
	
    
    public static List list_U(File file) throws Exception
    {return list_U(text(file));}
    
    public static List list_U(URL url) throws Exception
    {return list_U(text(url));}
    
    public static List list_U(String text) throws Exception
    {
    	ArrayList list = new ArrayList();
    	String[] lines = toArray(text);
        for(int i=0;i<lines.length;i++)
        list.add(decodeU(lines[i]));
        return list;
    }
    
    public static List list_US(File file) throws Exception
    {
    	ArrayList list = new ArrayList();
        if(file.length()==0)return list;
        if(!file.canRead()) throw new Exception("Cannot read file ["+file+"]");
        
        String[] lines = toArray(text(file));
        for(int i=0;i<lines.length;i++)
        list.add(text_US(lines[i],file));
        return list;
    }
    
    
    
    
    public static void writeProp_S(File file, Properties prop) throws Exception
    {writeProp(file,encrypt(prop,file));}
    
    public static void writeText_U(File file, String text) throws Exception
    {writeText(printStreamU(file),text);}
    
    public static void writeText_US(File file, String text) throws Exception
    {writeText(printStreamUS(file),text);}
    
    public static void writeSet_U(File file, Set set) throws Exception
    {writeSet(printStreamU(file),set);}
    
    public static void writeSet_US(File file, Set set) throws Exception
    {writeSet(printStreamUS(file),set);}
    
    public static void writeList_US(File file, List list) throws Exception
    {writeList(printStreamUS(file),list);}
    
    public static void writeList_U(File file, List list) throws Exception
    {writeList(printStreamU(file),list);}
    
}
