package gus05.manager.gus.kassia.layer3;

import java.util.Map;

import javax.swing.JFrame;

import gus05.framework.tools.DefaultSupport;
import gus05.manager.gus.kassia.layer3.t01.checkjavaversion.T01;
import gus05.manager.gus.kassia.layer3.t02.initerrorhandler.T02;
import gus05.manager.gus.kassia.layer3.t03.initexecuteexit.T03;
import gus05.manager.gus.kassia.layer3.t04.initexecuteprintdebug.T04;
import gus05.manager.gus.kassia.layer3.t05.initfileinitializer.T05;
import gus05.manager.gus.kassia.layer3.t06.initfileprovider.T06;
import gus05.manager.gus.kassia.layer3.t07.initfileprovider.pool.T07;
import gus05.manager.gus.kassia.layer3.t08.inituencoderdecoder.T08;
import gus05.manager.gus.kassia.layer3.t09.loadproperties.T09;
import gus05.manager.gus.kassia.layer3.t10.loadicons.T10;
import gus05.manager.gus.kassia.layer3.t11.loadsounds.T11;
import gus05.manager.gus.kassia.layer3.t12.loadlings.T12;
import gus05.manager.gus.kassia.layer3.t13.loadmapping.T13;
import gus05.manager.gus.kassia.layer3.t14.loadentityinfo.T14;
import gus05.manager.gus.kassia.layer3.t15.initentityproviders.T15;
import gus05.manager.gus.kassia.layer3.t16.initentitygenerator.T16;
import gus05.manager.gus.kassia.layer3.t17.initentityclassholder.T17;
import gus05.manager.gus.kassia.layer3.t18.initentityloader.T18;
import gus05.manager.gus.kassia.layer3.t19.initentityclassloader.T19;
import gus05.manager.gus.kassia.layer3.t20.initentityclassloader_bin.T20;
import gus05.manager.gus.kassia.layer3.t21.initentityclassloader_jar.T21;
import gus05.manager.gus.kassia.layer3.t22.initresourcecaller.T22;
import gus05.manager.gus.kassia.layer3.t23.initservicecaller.T23;
import gus05.manager.gus.kassia.layer3.t24.initdataprovider.T24;
import gus05.manager.gus.kassia.layer3.t25.initdatabuilder.T25;
import gus05.manager.gus.kassia.layer3.t26.initdatasourcefinder.T26;
import gus05.manager.gus.kassia.layer3.t27.initdatapersistence.T27;
import gus05.manager.gus.kassia.layer3.t28.initdatabackup.T28;
import gus05.manager.gus.kassia.layer3.t29.initlingsupport.T29;
import gus05.manager.gus.kassia.layer3.t30.initactionbuilder.T30;
import gus05.manager.gus.kassia.layer3.t31.initactionhandler.T31;
import gus05.manager.gus.kassia.layer3.t32.initactionupdater.T32;
import gus05.manager.gus.kassia.layer3.t33.initactioninfobuilder.T33;
import gus05.manager.gus.kassia.layer3.t34.initresourceprovider.T34;
import gus05.manager.gus.kassia.layer3.t35.initresourceprovider.basic.T35;
import gus05.manager.gus.kassia.layer3.t36.initresourceprovider.output.T36;
import gus05.manager.gus.kassia.layer3.t37.initresourceprovider.file.T37;
import gus05.manager.gus.kassia.layer3.t38.initresourceprovider.file1.T38;
import gus05.manager.gus.kassia.layer3.t39.initresourceprovider.dir.T39;
import gus05.manager.gus.kassia.layer3.t40.initresourceprovider.entity.T40;
import gus05.manager.gus.kassia.layer3.t41.initresourceprovider.entity1.T41;
import gus05.manager.gus.kassia.layer3.t42.initresourceprovider.data.T42;
import gus05.manager.gus.kassia.layer3.t43.initresourceprovider.data1.T43;
import gus05.manager.gus.kassia.layer3.t44.initresourceprovider.process.T44;
import gus05.manager.gus.kassia.layer3.t45.initresourceprovider.wrap.T45;
import gus05.manager.gus.kassia.layer3.t46.initresourceprovider.combine.T46;
import gus05.manager.gus.kassia.layer3.t47.initresourceprovider.lingprovider.T47;
import gus05.manager.gus.kassia.layer3.t48.initresourceprovider.iconprovider.T48;
import gus05.manager.gus.kassia.layer3.t49.initresourceprovider.actionbuilder.T49;
import gus05.manager.gus.kassia.layer3.t50.initresourceprovider.putpool.T50;
import gus05.manager.gus.kassia.layer3.t51.initmainframe.T51;
import gus05.manager.gus.kassia.layer3.t52.initmainguibuilder.T52;
import gus05.manager.gus.kassia.layer3.t53.initlogfile.T53;
import gus05.manager.gus.kassia.layer3.tools.Tool_debug;
import gus05.manager.gus.kassia.layer3.tools.printstream.PrintStream_Err;
import gus05.manager.gus.kassia.layer3.tools.printstream.PrintStream_Log;
import gus05.manager.gus.kassia.layer3.tools.printstream.PrintStream_Out;
import gus05.manager.gus.kassia.layer3.v01.customizepool.V01;
import gus05.manager.gus.kassia.layer3.v02.customizeproviders.V02;
import gus05.manager.gus.kassia.layer3.v03.handlestartlist.V03;
import gus05.manager.gus.kassia.layer3.v04.initmaingui.V04;
import gus05.manager.gus.kassia.layer3.v05.decorateframe.V05;




public class KS4_start extends KS3_data {
	
	
	private static long startDuration;
	private static long initpool_start;
	private static long initpool_end;
	private static long buildapp_start;
	private static long buildapp_end;
	private static long startapp_start;
	private static long startapp_end;
	
	
	
	
	
	public static void start() throws Exception
	{
		if(!errors.isEmpty())
			throw new Exception("Error list already contains "+errors.size()+" elements");
		
        putPool(POOL_MAP_SYSPROP,System.getProperties());
        putPool(POOL_MAP_SYSENV,System.getenv());
        putPool(POOL_PRINTSTREAM_SYSOUT,System.out);
        putPool(POOL_PRINTSTREAM_SYSERR,System.err);
        putPool(POOL_MAP_CONSTANTS,constants());
        putPool(POOL_SUPPORT_START,new DefaultSupport());
        putPool(POOL_SUPPORT_EXIT,new DefaultSupport());
        putPool(POOL_SUPPORT_EXIT2,new DefaultSupport());
        putPool(POOL_FILTER_TRUE,trueFilter);
        putPool(POOL_FILTER_FALSE,falseFilter);
        putPool(POOL_TRANSFORM_ID,idTransform);
        putPool(POOL_GRAPHIC_PANEL,panelGraphic);
        
        initPropMap();
        initPrintStreams();
        
        printM_("start()","printstreams initialized");
        printM_("start()","manager ID: ["+MANAGERID+"]");
        printM_("start()","internal id: ["+appGus05ID()+"]");
        printM_("start()","internal state: "+systemState());
        if(hasArgs()) printM_("start()","arguments line: ["+appArgsLine+"]");
    	
    	
    	
        nextPhase_poolInitialization();
        initPool();

        nextPhase_applicationBuild();
        buildApp();

        nextPhase_applicationStart();	
        startApp();

        nextPhase_applicationSummary();	
        presentApp();

        nextPhase_applicationRuntime();
	}


	
	

	
	
	
	
	
	
	
	
	private static void initPropMap()
	{
		putPoolMap(POOL_MAP_PROPS);
		map_props().putAll(props);
	}
	
	
	
	
	
	private static void initPrintStreams() throws Exception
	{
		PrintStream_Log p_log = new PrintStream_Log();
		PrintStream_Out p_out = new PrintStream_Out(p_log);
		PrintStream_Err p_err = new PrintStream_Err(p_log);
        
        System.setOut(p_out);
        System.setErr(p_err);
        
        p_log.sysOutEnabled = sysout() || debug();
        
        putPool(POOL_PRINTSTREAM_APP_LOG,p_log);
        putPool(POOL_PRINTSTREAM_APP_OUT,p_out);
        putPool(POOL_PRINTSTREAM_APP_ERR,p_err);
	}
	
	
	
	
	
	

    
	
	
	
	
	
	
	private static void initPool() throws Exception
	{
		initpool_start = millis();
		
		lapse();
		T01.checkJavaVersion();t();
        T02.initErrorHandler();t();
        T03.initExecuteExit();t();
        T04.initExecutePrintDebug();t();
        T05.initFileInitializer();t();
        T06.initFileProvider();t();
        T07.initFileProvider_pool();t();
        T08.initUEncoderDecoder();t();
		
		// resource loading
        T09.loadProperties();t();
        T10.loadIcons();t();
        T11.loadSounds();t();
        T12.loadLings();t();
        T13.loadMapping();t();
        T14.loadEntityInfo();t();
		
		// entity generation
        T15.initEntityProviders();t();
        T16.initEntityGenerator();t();
        T17.initEntityClassHolder();t();
        T18.initEntityLoader();t();
        T19.initEntityClassLoader();t();
        T20.initEntityClassLoader_Bin();t();
        T21.initEntityClassLoader_Jar();t();
        
        // callers
        T22.initResourceCaller();t();
        T23.initServiceCaller();t();
        
		// data provider
        T24.initDataProvider();t();
        T25.initDataBuilder();t();
        T26.initDataSourceFinder();t();
        T27.initDataPersistence();t();
        T28.initDataBackup();t();
        
        // ling & action
        T29.initLingSupport();t();
        T30.initActionBuilder();t();
        T31.initActionHandler();t();
        T32.initActionUpdater();t();
		T33.initActionInfoBuilder();t();
		
		// resource provider
        T34.initResourceProvider();t();
        T35.initResourceProvider_basic();t();
        T36.initResourceProvider_output();t();
        T37.initResourceProvider_file();t();
        T38.initResourceProvider_file1();t();
        T39.initResourceProvider_dir();t();
        T40.initResourceProvider_entity();t();
        T41.initResourceProvider_entity1();t();
        T42.initResourceProvider_data();t();
        T43.initResourceProvider_data1();t();
		T44.initResourceProvider_process();t();
        T45.initResourceProvider_wrap();t();
        T46.initResourceProvider_combine();t();
        T47.initResourceProvider_lingProvider();t();
        T48.initResourceProvider_iconProvider();t();
        T49.initResourceProvider_actionBuilder();t();
        T50.initResourceProvider_putpool();t();
		
        // last pool objects
        T51.initMainFrame();t();
        T52.initMainGuiProvider();t();
        T53.initLogFile();t();
        
        initpool_end = millis();
	}
	
	private static int t = 0;
    
    private static void t()
    {printD_("initPool()","time@t"+formatN2(++t)+": "+n_(ms(lapse())));}
	
	
    
    
	
	
	
    
    
	private static void buildApp() throws Exception
	{
		if(number_instanciatedEntities>0)
    		throw new Exception(number_instanciatedEntities+ "entities have been instanciated before APPLICATION BUILD phase");
		
	    buildapp_start = millis();
		
		lapse();
		V01.customizePool();v();
        V02.customizeProviders();v();
        V03.handleStart();v();
        V04.initMainPanel();v();
        V05.decorateFrame();v();
        
        buildapp_end = millis();
	}
	
	private static int v = 0;
    
    private static void v()
    {printD_("buildApp()","time@v"+formatN2(++v)+": "+n_(ms(lapse())));}
	
	
    
    
	
	
    
    
    
    
    
    
    private static void startApp()
    {
    	startapp_start = millis();
    	
    	JFrame f = mainFrame();
    	if(f==null) printW_("startApp()","MainFrame not found inside pool");
    	else handleSetVisible(f);
    	
    	DefaultSupport s = supportStart();
    	if(s==null) printW_("startApp()","SupportStart not found inside pool");
    	else handleSupportStart(s);
    	
    	startDuration = timeFromStart();
        putPool(POOL_LONG_STARTDURATION, new Long(startDuration));
    	
    	startapp_end = millis();
    }
    
    
	
	
	private static void handleSetVisible(JFrame f)
	{
		if(!booleanProp(PROPKEY_APPVISIBLEONSTART,true)) return;
		printM_("handleSetVisible(JFrame)","setVisible(true)");
		f.setVisible(true);
	}
	
	
	private static void handleSupportStart(DefaultSupport s)
    {
		int n = s.listeners().size();
    	if(n==0) {printM_("handleSupportStart(DefaultSupport)","no task found");return;}
    	printM_("handleSupportStart(DefaultSupport)","send:start ("+n+" tasks found)");
		s.send(KS4_start.class,"start");
    }
    
    
	
	
	
	
    
    
	
    
    
    
    
    
    private static void presentApp()
    {
    	printM_("presentApp()"," App identity");
    	printM_("presentApp()"," . app title = ["+appTitle()+"]");
    	printM_("presentApp()"," . app name = ["+appName()+"]");
    	printM_("presentApp()"," . app version = ["+appVersion()+"]");
    	printM_("presentApp()"," . app build = ["+appBuild()+"]");
    	printM_("presentApp()"," . app gus05 ID = ["+appGus05ID()+"]");
    	
    	printM_("presentApp()"," Launch env");
    	printM_("presentApp()"," . app directory = "+display(DIR_SYS_USERDIR));
    	printM_("presentApp()"," . app start time = ["+startDate()+"]");
    	printM_("presentApp()"," . java home = "+display(DIR_SYS_JAVAHOME));
    	printM_("presentApp()"," . java version = ["+SYS_JAVAVERSION+javaVersionGap()+"]");
    	
    	printM_("presentApp()"," Launch config");
    	printM_("presentApp()"," . arguments line = ["+appArgsLine+"]");
    	printM_("presentApp()"," . root directory = "+display(file(FILEID_ROOTDIR)));
    	printM_("presentApp()"," . prop file = "+display(file(FILEID_PROPFILE)));
    	printM_("presentApp()"," . log file = "+display(file(FILEID_LOGFILE)));
    	
    	printM_("presentApp()"," Runtime state");
    	printM_("presentApp()"," . app maingui key = "+getProp(PROPKEY_APPMAINGUI,null));
    	printM_("presentApp()"," . app maingui comp = "+sourceName(getPool(POOL_JCOMPONENT_MAINGUI)));
    	printM_("presentApp()"," . internal state: "+systemState());
    	printM_number("presentApp()"," . entity"," . no entity found",map_entityClasses());
    	printM_number("presentApp()"," . prop"," . no prop found",map_props());
    	printM_number("presentApp()"," . icons"," . no icon found",map_icons());
    	printM_number("presentApp()"," . sounds"," . no sound found",map_sounds());
    	printM_number("presentApp()"," . lings"," . no ling found",map_lings());
    	
    	printM_("presentApp()"," Java Threads");
    	printM_("presentApp()"," . active count: "+Thread.activeCount());
    	printM_("presentApp()"," . current thread: "+Thread.currentThread().getName()+" (id="+Thread.currentThread().getId()+")");
    	
    	if(number_loadIcon>0 || number_loadAudio>0)
    	{
    		printM_("presentApp()"," URL Resources loading time");
        	if(number_loadIcon>0) printM_("presentApp()"," . "+number_loadIcon+" icon(s):  "+n_(ms(time_loadIcon)));
        	if(number_loadAudio>0) printM_("presentApp()"," . "+number_loadAudio+" sound(s): "+n_(ms(time_loadAudio)));
    	}
    	
    	if(number_instanciatedEntities>0)
    	{
    		printM_("presentApp()"," Entities instanciation");
    		printM_("presentApp()"," . "+number_instanciatedEntities+" entity objects created");
    	}
    	
    	printM_("presentApp()"," Start durations");
    	printM_("presentApp()"," . initsys duration:  "+n_(ms(initpool_start-appStartDate.getTime())));
        printM_("presentApp()"," . initpool duration: "+n_(ms(initpool_end-initpool_start)));
        printM_("presentApp()"," . buildapp duration: "+n_(ms(buildapp_end-buildapp_start)));
        printM_("presentApp()"," . startapp duration: "+n_(ms(startapp_end-startapp_start)));
        printM_("presentApp()"," . total duration:    "+n_(ms(startDuration)));
        
        if(!errors.isEmpty())
        {
        	int n = errors.size();
        	if(n==1) printW_("presentApp()","1 error has occured");
        	else printW_("presentApp()",n+" errors have occured");
        }
        Tool_debug.printAppDebugInfo();
    }
    
    
    
    
    
    
    
    
    
    
	
	
    private static void printM_number(String id, String message, String emptyMessage, Map map)
	{
    	if(map!=null && !map.isEmpty()) printM_(id,message+" number = "+map.size());
    	else printM_(id,emptyMessage);
    }
    
	
	private static void printM_(String id, String message)
	{printM(KS4_start.class,id,message);}
    
    private static void printW_(String id, String message)
	{printW(KS4_start.class,id,message);}
    
    private static void printD_(String id, String message)
	{printD(KS4_start.class,id,message);}
    
    
    
    
    private static String n_(String s)
    {return formatN(s," ",12);}
}
