package gus05.manager.gus.kassia.layer3.t01.checkjavaversion;

import javax.swing.JOptionPane;

import gus05.manager.gus.kassia.layer3.KS3_data;

public class T01 extends KS3_data {

	
	
	
	public static void checkJavaVersion() throws Exception
	{
		if(hasArg(ARGVALUE_DISABLEJAVACHECK)) return;
    	if(!hasProp(PROPKEY_APPJAVAVERSION)) return;

    	String appJavaVersion = getProp(PROPKEY_APPJAVAVERSION);
    	if(appJavaVersion.equals("")) return;
    	if(Tools_javaVersion.isJavaVersionSupported(appJavaVersion)) return;

    	
    	String w = "This application requires Java version ["+appJavaVersion+"]\n" +
    			"Current installed Java version is ["+SYS_JAVAVERSION+"]";
    	String q = "The application may not execute properly.\nDo you wish to continue anyway ?";

    	int value = JOptionPane.showConfirmDialog(null,w+"\n\n"+q,
    			"JAVA COMPATIBILITY WARNING",
    			JOptionPane.YES_NO_OPTION,
    			JOptionPane.WARNING_MESSAGE);

    	if(value==JOptionPane.NO_OPTION)
    		throw new Exception(w);
    	
    	String[] gap = new String[]{SYS_JAVAVERSION,appJavaVersion};
    	putPool(POOL_STRINGARRAY_JAVAVERSIONGAP,gap);
	}
}
