package gus05.manager.gus.kassia.layer3.t14.loadentityinfo;

import java.io.File;
import java.util.Iterator;
import java.util.Map;
import java.util.Properties;

import gus05.manager.gus.kassia.layer3.tools.AbstractResourceLoader;

public class T14 extends AbstractResourceLoader {

	
	
	public static void loadEntityInfo() throws Exception
	{
		putPoolMap(POOL_MAP_ENTITYMULTIPLICITY);
		map_multiplicity().putAll(multiplicities);
		
    	new T14().load("entity info", PROPKEY_SEQUENCE_LOADENTITYINFO, "");
	}
	
	
	
    
	protected void load_fromInside_(int index, String resourceID) throws Exception {}

	protected void load_fromPathID_(int index, String pathID) throws Exception
	{
		File f = file(pathID);
		if(f!=null && f.exists()) loadEntityInfo_fromFile(f);
	}



    
    
    private void loadEntityInfo_fromFile(File f) throws Exception
    {
    	Properties p = prop(f);
    	if(!p.isEmpty()) loadInfo_fromProp(p);
    }
    
    
    
    private void loadInfo_fromProp(Properties p)
    {
    	Map m = map_multiplicity();
    	Iterator it = p.keySet().iterator();
    	while(it.hasNext())
    	{
    		String entityName = (String) it.next();
    		if(!entityName.startsWith("#"))
    		{
    			String info = p.getProperty(entityName);
        		
    			if(info.equalsIgnoreCase(MULTIPLICITYVALUE_MULTIPLE) || info.endsWith("*"))
        			m.put(entityName,MULTIPLICITYVALUE_MULTIPLE);
        		else if(info.equalsIgnoreCase(MULTIPLICITYVALUE_UNIQUE) || info.endsWith("+"))
        			m.put(entityName,MULTIPLICITYVALUE_UNIQUE);
        		else
        			printW(this,"loadInfo_fromProp(Properties)","Invalid entity info: "+info);
    		}
    	}
    }
    
}
