package gus05.manager.gus.kassia.layer3.t17.initentityclassholder;

import java.util.Map;

import gus05.framework.features.Give;
import gus05.framework.features.Retrieve;
import gus05.framework.features.Transform;
import gus05.manager.gus.kassia.layer3.KS3_data;

public class T17 extends KS3_data implements Retrieve, Transform {

	
	
	
	public static void initEntityClassHolder() throws Exception
    {
    	putPoolMap(POOL_MAP_ENTITYCLASSES);
    	putPool(POOL_RETRIEVE_ENTITYCLASSHOLDER,new T17());
    	
        map_entityClasses().putAll(entities);
    }
	
	
	public Object retrieve(String key) throws Exception
	{return getEntityClass_(key);}
	
	public Object transform(Object obj) throws Exception
	{return getEntityClass_((String)obj);}
	
	
	
	
	
	private Class getEntityClass_(String name) throws Exception
	{
		Map m = map_entityClasses();
		if(!m.containsKey(name))loadMissingEntity_(name);
		if(!m.containsKey(name))throw new Exception("Unable to load entity: ["+name+"]");
		
		return (Class) m.get(name);
	}
    
    
    
    private void loadMissingEntity_(String name) throws Exception
    {	
    	Give loader = entityLoader();
        if(loader==null) throw new Exception("No entity loader available inside pool");
        loader.give(name);
    }
}
