package gus05.manager.gus.kassia.layer3.t18.initentityloader;

import java.util.Map;

import gus05.framework.features.Give;
import gus05.framework.features.Retrieve;
import gus05.manager.gus.kassia.layer3.KS3_data;

public class T18 extends KS3_data implements Give {

	
	
	public static void initEntityLoader() throws Exception
    {
    	putPool(POOL_GIVE_ENTITYLOADER,new T18());
    }
    
    

	public void give(Object obj) throws Exception
	{
		String name = (String) obj;
		
		Map m = map_entityClasses();
    	if(m.containsKey(name)) return;
    	
    	if(!booleanProp(PROPKEY_ENTITYLOADENABLED,true))
    		throw new Exception("Unknown entity: ["+name+"]");
    	
    	checkLoadSecurity(name);
    	
		// load entity
		Retrieve classLoader = entityClassLoader();
        if(classLoader==null) throw new Exception("No entity class loader available inside pool");
        
        Class c = (Class) classLoader.retrieve(name);
        if(c==null) throw new Exception("Unknown entity: ["+name+"]");
        m.put(name,c);
        
    	Give paramLoader = poolgive(POOL_GIVE_ENTITYPARAMLOADER);
    	if(paramLoader!=null) paramLoader.give(name);
	}
	
	
	
	
	
	
	
	private void checkLoadSecurity(String name) throws Exception
	{
		if(hasArg(ARGVALUE_DISABLEENTITYSECURITY)) return;
		Give loadSecurity = poolgive(POOL_GIVE_ENTITYLOADSECURITY);
		if(loadSecurity!=null) loadSecurity.give(name);
	}
}
