package gus05.manager.gus.kassia.layer3.t21.initentityclassloader_jar;

import java.io.File;
import java.util.HashMap;

import gus05.framework.features.Transform;
import gus05.manager.gus.kassia.layer3.KS3_data;


public class T21 extends KS3_data implements Transform {

	
	
	public static void initEntityClassLoader_Jar() throws Exception
	{putPool(POOL_TRANSFORM_ENTITYCLASSLOADER_JAR,new T21());}
	
	
	
	public Object transform(Object obj) throws Exception
	{
		File file = prepareFile((File)obj);
		return findEntityClassLoader(file);
	}
	
	
	
	private HashMap map = new HashMap();
	
	private Object findEntityClassLoader(File file) throws Exception
	{
		if(!map.containsKey(file))
		map.put(file,new EntityClassLoader_jar(file));
		return map.get(file);
	}
	
	
	
	
	private File prepareFile(File f) throws Exception
	{
		File cacheDir = file(FILEID_JARCACHEDIR);
		if(cacheDir==null) return f;
		
		File f_cache = new File(cacheDir,f.getName());
		copy(f,f_cache);
		return f_cache;
	}
}
