package gus05.manager.gus.kassia.layer3.t23.initservicecaller;


import gus05.framework.core.Entity;
import gus05.framework.core.Outside;
import gus05.framework.features.Give;
import gus05.framework.features.Retrieve;
import gus05.framework.features.Transform;
import gus05.manager.gus.kassia.layer3.KS3_data;


public class T23 extends KS3_data implements Transform, Give, Retrieve {

	
	
	public static void initServiceCaller() throws Exception
	{putPool(POOL_TRANSFORM_CALLSERVICE,new T23());}
	
	
	private Entity entity;
	
	public void give(Object obj) throws Exception
	{entity = (Entity) obj;}

	
	public Object retrieve(String key) throws Exception
	{
		if(entity==null) return Outside.service(ANONYMOUS_ENTITY,key);
		return Outside.service(entity,key);
	}
	
	public Object transform(Object obj) throws Exception
	{return retrieve((String)obj);}
}
