package gus05.manager.gus.kassia.layer3.t24.initdataprovider;


import java.util.Map;

import gus05.framework.features.Give;
import gus05.framework.features.Retrieve;
import gus05.framework.features.Transform;
import gus05.manager.gus.kassia.layer3.KS3_data;

public class T24 extends KS3_data implements Retrieve, Transform {

	
	
	public static void initDataProvider() throws Exception
	{
        putPoolMap(POOL_MAP_DATAOBJECT);
        putPool(POOL_RETRIEVE_DATAPROVIDER,new T24());
	}
	
	
	public Object retrieve(String key) throws Exception
	{return provideData(key);}
	
	public Object transform(Object obj) throws Exception
	{return provideData((String) obj);}
	
	
	
	
	private Object provideData(String id) throws Exception
	{
		Map m = map_dataObject();
		if(!m.containsKey(id)) buildData(id);
		if(!m.containsKey(id)) throw new Exception("Unable to build data: ["+id+"]");
		
		return m.get(id);
	}
	
	
	private void buildData(String id) throws Exception
	{
		Give builder = dataBuilder();
		if(builder==null) throw new Exception("Data builder not available inside pool");
		builder.give(id);
	}
}
