package gus05.manager.gus.kassia.layer3.t31.initactionhandler;


import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Iterator;
import java.util.Map;

import javax.swing.Action;

import gus05.framework.features.Give;
import gus05.manager.gus.kassia.layer3.KS3_data;



public class T31 extends KS3_data implements Give {

	
	
	public static void initActionHandler()
	{
		putPoolMap(POOL_MAP_ACTIONS);
		putPool(POOL_GIVE_ACTIONHANDLER,new T31());
		
		supportLing().addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {updateAllActions();}
		});
	}

	
	
	public void give(Object obj) throws Exception
	{handleAction((Action)obj);}

	
	
	
	
	private void handleAction(Action action)
    {
		Map m = map_actions();
		
		int i=0;
		String id = action.toString();
        while(m.containsKey(id+":"+i))i++;
        m.put(id+":"+i,action);
        
        updateAction(action);
    }
	
	
	
	
	
	
	private static void updateAllActions()
	{
		Map m = map_actions();
		Iterator it = m.keySet().iterator();
        while(it.hasNext())
        {
            String key = (String)it.next();
            Action action = (Action) m.get(key);
            updateAction(action);
        }
	}
	
	
	
	private static void updateAction(Action action)
    {
		try
		{
			Give g = poolgive(POOL_GIVE_ACTIONUPDATER);
    		if(g!=null) g.give(action);
		}
		catch(Exception e)
		{err(T31.class,"updateAction(Action)",e);}
    }
}
