package gus05.manager.gus.kassia.layer3.t39.initresourceprovider.dir;


import java.io.File;

import gus05.framework.core.Entity;
import gus05.manager.gus.kassia.layer3.tools.AbstractResourceProvider;


public class T39 extends AbstractResourceProvider {

	
	
	public static void initResourceProvider_dir()
	{map_providers().put(PROVIDER_DIR,new T39());}
	
	
	
	public Object retrieveResource(Entity entity, String id, String key) throws Exception
    {
		File dir = key.equals("pool")?poolDir(entity,id):file(key);
        if(dir==null) throw new Exception("Unknown fileID: ["+key+"]");

        if(!dir.exists()) initDir(dir);
        if(!dir.exists()) throw new Exception("FileID ["+key+"] is not an existing path: ["+dir+"]");
        if(!dir.isDirectory()) throw new Exception("FileID ["+key+"] is not a directory path: ["+dir+"]");
        return dir;
    }
}
