package gus05.manager.gus.kassia.layer3.t52.initmainguibuilder;


import javax.swing.JComponent;

import gus05.framework.features.Graphic;
import gus05.framework.features.Provide;
import gus05.manager.gus.kassia.layer3.KS3_data;


public class T52 extends KS3_data implements Provide {

	
	public static void initMainGuiProvider()
    {putPool(POOL_PROVIDE_MAINGUIBUILDER,new T52());}



	public Object provide() throws Exception
	{
		String maingui = getProp(PROPKEY_APPMAINGUI,null);
		String mainguifailed = getProp(PROPKEY_APPMAINGUIFAILED,null);
		
		try
		{
			return build(maingui);
		}
		catch(Exception e)
		{
			if(mainguifailed==null) throw e;
			err(T52.class,"provide()",e);
		}
		
		printM(this,"provide()","Try and provide main gui with failed maingui key");
		return build(mainguifailed);
	}
	
	
	
	
	
	
	
	
	
	private JComponent build(String key) throws Exception
	{
        try
		{
        	printM(this,"build(String)","Providing main gui with key=["+key+"]");
    		if(key==null) return null;
    		
    		Graphic g = (Graphic) provideUniqueEntity(key);
            JComponent c = g.gui();
    		
            putPool(POOL_GRAPHIC_MAINGUI,g);
    		putPool(POOL_JCOMPONENT_MAINGUI,c);
        	
    		return c;
		}
		catch(Exception e)
		{
			String message = "Providing main gui failed with key=["+key+"]";
			throw new Exception(message,e);
		}
	}
}
