package gus05.manager.gus.kassia.layer3.tools.printstream;

import gus05.framework.features.Give;
import gus05.framework.features.Register;

import java.io.PrintStream;
import java.util.ArrayList;
import java.util.List;


public class PrintStream_Basic extends PrintStream0 implements Give, Register {

    private ArrayList list;
    private StringBuffer buffer;
    public List list() {return list;}
    
    
    public PrintStream_Basic()
    {
        super();
        list = new ArrayList();
        buffer = new StringBuffer();
    }
    
    
    
    public void addPrintStream(PrintStream out)
    {list.add(out);}
    
    public void removePrintStream(PrintStream out)
    {list.remove(out);}
    
    public void initPrintStream(PrintStream out)
    {out.print(buffer);addPrintStream(out);}
    
    public PrintStream out(int index)
    {return (PrintStream) list.get(index);}
    
    
    
    
    
    public void register(String key, Object obj) throws Exception
    {
        PrintStream out = (PrintStream)obj;
        if(key.equals("add")) {addPrintStream(out);return;}
        if(key.equals("remove")) {removePrintStream(out);return;}
        
        throw new Exception("Unknown key: "+key);
    }

    public void give(Object obj) throws Exception
    {initPrintStream((PrintStream)obj);}
    
    
    
    
    
    
    
    public void print(String m)
    {
        buffer.append(m);
        for(int i=0;i<list.size();i++) out(i).print(m);
    }
    
    public void println(String m)
    {
        buffer.append(m+"\n");
        for(int i=0;i<list.size();i++) out(i).println(m);
    }
    
    public void close()
    {for(int i=0;i<list.size();i++) out(i).close();}
    
    public String toString()
    {return buffer.toString();}
}
