package gus05.manager.gus.kassia.layer3.t37.initresourceprovider.file;


import java.io.File;

import gus05.framework.core.Entity;
import gus05.manager.gus.kassia.layer3.tools.AbstractResourceProvider;


public class T37 extends AbstractResourceProvider {

	
	
	public static void initResourceProvider_file()
	{map_providers().put(PROVIDER_FILE,new T37());}

	
	
	public Object retrieveResource(Entity entity, String id, String key) throws Exception
    {
		File file = key.equals("pool")?poolFile(entity,id):file(key);
    	if(file==null) throw new Exception("Unknown fileID: ["+key+"]");

        if(!file.exists()) initFile(file);
        if(!file.exists()) throw new Exception("FileID ["+key+"] is not an existing path: ["+file+"]");
        if(!file.isFile()) throw new Exception("FileID ["+key+"] is not a file path: ["+file+"]");
        return file;
    }
}
