package gus05.manager.gus.kassia.layer3.tools.printstream;

import java.io.PrintStream;




public class PrintStream_Log extends PrintStream_Basic {
	
	
	private PrintStream sysOut0;
    public boolean sysOutEnabled = false;
    
    private int lineNb = 0;
    
    private String line(String m)
    {
        lineNb++;
        if(lineNb<10) return "000"+lineNb+" "+m;
        if(lineNb<100) return "00"+lineNb+" "+m;
        if(lineNb<1000) return "0"+lineNb+" "+m;
        return lineNb+" "+m;
    }
    
    
    public PrintStream_Log()
    {
    	super();
    	sysOut0 = System.out;
    }
    
    
    
    
    
    public void print(String m)
    {
        super.print(m);
        if(sysOutEnabled) sysOut0.print(m);
    }
    
    public void println(String m)
    {
        m = line(m);
        super.println(m);
        if(sysOutEnabled) sysOut0.println(m);
    }
}
