package gus05.manager.gus.kassia.layer3.v04.initmaingui;

import javax.swing.JComponent;
import javax.swing.JFrame;

import gus05.framework.features.Provide;
import gus05.manager.gus.kassia.layer3.KS3_data;


public class V04 extends KS3_data {

	
	public static void initMainPanel()
	{
		JFrame f = mainFrame();
		if(f==null) return;

		JComponent content = buildContent();
		printM(V04.class,"initMainPanel()","Initializing main panel: ["+sourceName(content)+"]");
		f.setContentPane(scroll(content));
	}
	
	
	
	
    private static JComponent buildContent()
    {
    	try
    	{
    		Provide p = mainGuiProvider();
        	if(p==null) throw new Exception("Main gui provider not found inside pool");
        	
        	JComponent comp = (JComponent) p.provide();
        	if(comp==null) comp = new EmptyPanel();
        	return console()?new ConsolePanel(comp):comp;
    	}
    	catch(Exception e)
    	{
    		err(V04.class,"buildContent()",e);
    		return new ConsolePanel(e);
    	}
    }
}
